Subject: Overhaul annotation support/syntax

Description

| think it would be wise to decide on this before 1.0.0, the earlier the better. It has been discussed here and there in the past, but we
need to get this thought through.

So, here are the basic questions:

1. Do we adopt UpperCamelCase and case-sensitivity, like Doctrine 2 and Symfony 2 use it?
2. Do we switch annotation parsing to the Doctrine Common library?
The case thing means
- consistency with Doctrine annotations we have in place already
- inconsistency with "normal" docblock APl annotations
- the latter can be softened by using prefixes on annotations and have them lowercased, see
http://symfony.com/blog/symfony2-annotations-gets-better for examples

The parser library switch would
- move the burden of maintaining a parser away from us
- force us to adapt the current annotation syntax
- possibly allow more flexibility

Related issues:
related to TYPOS.Flow - Bug # 31015: Second classloader in ReflectionService ... Resolved 2011-10-17

History

#1 - 2011-06-21 17:40 - Bastian Waidelich

| would go for 1 & 2.
If I got it right, this would change the annotations like this:

@scope prototype -> @Scope(type="prototype")
@scope singleton -> @Scope(type="singleton")

@validate StringLength(minimum = 1, maximum = 100) -> @Validate(validator="StringLength", options="{"minimum" = "1", "maximum" =
"100"}")

| don't think, that the inconsistency with "normal” docblock APl annotations is a problem, because IMO there's a "mental gap" between those anyways,
but that's just my subjective opinion.

#2 - 2011-06-22 07:04 - Sebastian Kurfuerst
http://symfony.com/blog/symfony2-annotations-gets-better

- 1): +1 from my side

- 2): it definitely makes sense to use another framework, as maintaining such a parser always sucks ;)

If I got it correctly, we'd need to decide between the following annotation formats:

- @Scope(type="prototype") vs @f3:Scope(type="prototype")
- @Validate(validator) vs @f3:Validate....

So we still have to decide whether we put all FLOW3 annotations into F3\FLOW3\Annotations (so that they can be referenced without namespace), or

if we define prefixes. For validation, things like:

- @validate:StringLength(....) would also make a lot of sense IMHO.

What do you think? So it basically boils down how to set "defaultAnnotationNamespace" and "annotationNamespaceAlias" in

http://www.doctrine-project.org/projects/common/2.0/docs/reference/annotations/en#annotations

#3 - 2011-08-04 08:51 - Sebastian Kurfuerst
- Target version changed from 1230 to 1.0 beta 2

#4 - 2011-09-09 10:41 - Karsten Dambekalns
- Target version changed from 1.0 beta 2 to 1.0.0

#5 - 2011-09-30 10:22 - Karsten Dambekalns
- Category set to Reflection
- Status changed from Needs Feedback to Accepted

#6 - 2011-10-14 14:17 - Karsten Dambekalns
- Status changed from Accepted to Under Review

#7 - 2011-10-19 09:46 - Karsten Dambekalns

- Status changed from Under Review to Accepted
- % Done changed from 0 to 90

Documentation update is pending.

#8 - 2011-10-20 01:25 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 90 to 100
